package com.jiuqi.util.comparator;

package .tmp;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;

public final class AggreatedComparator implements Comparator {
  private List comparators = new ArrayList();
  
  public int compare(Object o1, Object o2) {
    if (o1 == o2)
      return 0; 
    if (o1 == null)
      return -1; 
    if (o2 == null)
      return 1; 
    Object[] arr1 = (Object[])o1;
    Object[] arr2 = (Object[])o2;
    int len = Math.min(Math.min(arr1.length, arr2.length), this.comparators.size());
    for (int i = 0; i < len; i++) {
      Comparator<Object> c = this.comparators.get(i);
      int ret = c.compare(arr1[i], arr2[i]);
      if (ret != 0)
        return ret; 
    } 
    return 0;
  }
  
  public boolean equals(Object obj) {
    if (this == obj)
      return true; 
    if (this == null || obj == null)
      return false; 
    if (obj instanceof com.jiuqi.util.comparator.AggreatedComparator) {
      com.jiuqi.util.comparator.AggreatedComparator cmp = (com.jiuqi.util.comparator.AggreatedComparator)obj;
      if (this.comparators.size() != cmp.comparators.size())
        return false; 
      for (int i = 0; i < this.comparators.size(); i++) {
        if (!this.comparators.get(i).equals(cmp.comparators.get(i)))
          return false; 
      } 
      return true;
    } 
    return false;
  }
  
  public String toString() {
    StringBuffer result = new StringBuffer("[聚合比较器");
    for (int i = 0; i < this.comparators.size(); i++) {
      result.append(", ");
      result.append(this.comparators.get(i));
    } 
    result.append("]");
    return result.toString();
  }
  
  public void addComparator(Comparator comparator) {
    this.comparators.add(comparator);
  }
  
  public void removeComparator(Comparator comparator) {
    this.comparators.remove(comparator);
  }
  
  public Comparator[] getAllComparators() {
    return (Comparator[])this.comparators.toArray((Object[])new Comparator[0]);
  }
}
